Index: /trunk/AddOn/TAcq/brbaseproc.cc
===================================================================
--- /trunk/AddOn/TAcq/brbaseproc.cc	(revision 3938)
+++ /trunk/AddOn/TAcq/brbaseproc.cc	(revision 3939)
@@ -13,5 +13,7 @@
 using namespace SOPHYA;
 //---------------------------------------------------------------------
-// Classe de traitement - calcul de visibilite pour n fibres 
+// Classe BRBaseProcessor : classe de base pour l'analyse des donnees 
+// BAORadio - Les classes de traitement heritent de cette classe et 
+// redefinissent la mathode Process() qui est appele paquet par paquet
 //---------------------------------------------------------------------
 
Index: /trunk/AddOn/TAcq/brbaseproc.h
===================================================================
--- /trunk/AddOn/TAcq/brbaseproc.h	(revision 3938)
+++ /trunk/AddOn/TAcq/brbaseproc.h	(revision 3939)
@@ -3,5 +3,5 @@
 
 //----------------------------------------------------------------
-// Projet BAORadio - (C) LAL/IRFU  2008-2010
+// Projet BAORadio - (C) LAL/IRFU  2008-2011
 // Classes de threads de traitememt donnees BAORadio 
 //----------------------------------------------------------------
@@ -41,4 +41,5 @@
   // get Observation Time ( obtained from MemZoneMgr )
   inline SOPHYA::TimeStamp& getObsTime()  { return cts_; }
+  // Attention : les methodes suivantes ne sont pas protegees pour le numero de fibre
   // Renvoie le numero de frame-counter courant - si fgz=true, soustrait le FC du premier paquet 
   inline uint_8 getCurFrameCounter(size_t fib=0, bool fgz=true) 
Index: /trunk/AddOn/TAcq/brfitsrd.cc
===================================================================
--- /trunk/AddOn/TAcq/brfitsrd.cc	(revision 3938)
+++ /trunk/AddOn/TAcq/brfitsrd.cc	(revision 3939)
@@ -1,4 +1,4 @@
 //----------------------------------------------------------------
-// Projet BAORadio - (C) LAL/IRFU  2008-2010
+// Projet BAORadio - (C) LAL/IRFU  2008-2011
 // Classes de threads pour lecture fichiers fits BAORadio
 //----------------------------------------------------------------
Index: /trunk/AddOn/TAcq/brfitsrd.h
===================================================================
--- /trunk/AddOn/TAcq/brfitsrd.h	(revision 3938)
+++ /trunk/AddOn/TAcq/brfitsrd.h	(revision 3939)
@@ -3,5 +3,5 @@
 
 //----------------------------------------------------------------
-// Projet BAORadio - (C) LAL/IRFU  2008-2010
+// Projet BAORadio - (C) LAL/IRFU  2008-2011
 // Classes de threads pour lecture fichiers fits BAORadio
 //----------------------------------------------------------------
Index: /trunk/AddOn/TAcq/brproc.cc
===================================================================
--- /trunk/AddOn/TAcq/brproc.cc	(revision 3938)
+++ /trunk/AddOn/TAcq/brproc.cc	(revision 3939)
@@ -1,4 +1,4 @@
 //----------------------------------------------------------------
-// Projet BAORadio - (C) LAL/IRFU  2008-2010
+// Projet BAORadio - (C) LAL/IRFU  2008-2011
 // Classes de threads de traitement pour BAORadio 
 //----------------------------------------------------------------
@@ -32,6 +32,8 @@
 
 //---------------------------------------------------------------------
-// Classe de traitement de spectres - 
+// Classe BRMeanSpecCalculator de traitement de spectres - 
 // Calcul de spectres moyennes,variance / voie + nettoyage
+// Implementation de traitement par fenetres temps-frequence
+// Le temps correspond au numero de paquet
 //---------------------------------------------------------------------
 /* --Methode-- */
Index: /trunk/AddOn/TAcq/brproc.h
===================================================================
--- /trunk/AddOn/TAcq/brproc.h	(revision 3938)
+++ /trunk/AddOn/TAcq/brproc.h	(revision 3939)
@@ -3,5 +3,5 @@
 
 //----------------------------------------------------------------
-// Projet BAORadio - (C) LAL/IRFU  2008-2010
+// Projet BAORadio - (C) LAL/IRFU  2008-2011
 // Classes de threads de traitememt donnees BAORadio 
 //  Principales classes utilisables 
@@ -31,6 +31,10 @@
 //---------------------------------------------------------------------
 // Classe de traitement simple - calcul de spectres moyennes / voie
-// a partir de donnees de type FFT (firmware FFT)
-//---------------------------------------------------------------------
+// a partir de donnees de type FFT (firmware FFT ou firmware RAW 
+// apres traitement par BRFFTCalculator)
+// Peut servir egalement comme classe de base, apres heritage et 
+// redefinition des methodes ProcSpecWin() et/ou FlagBadPackets()
+//---------------------------------------------------------------------
+
 class BRMeanSpecCalculator : public BRBaseProcessor
 {
Index: /trunk/AddOn/TAcq/specmfib.cc
===================================================================
--- /trunk/AddOn/TAcq/specmfib.cc	(revision 3938)
+++ /trunk/AddOn/TAcq/specmfib.cc	(revision 3939)
@@ -6,5 +6,5 @@
    Programme de lecture multifibres, calcul de spectres 
    BAORadio -   LAL/IRFU      R. Ansari, C. Magneville
-   Septembre 2010 
+   Septembre 2010 - 2011
    ---------------------------------------------------------- */
 