Index: /trunk/AddOn/TAcq/chanum_1210.cc
===================================================================
--- /trunk/AddOn/TAcq/chanum_1210.cc	(revision 3940)
+++ /trunk/AddOn/TAcq/chanum_1210.cc	(revision 3941)
@@ -18,8 +18,8 @@
 #include "nbtrixx.h"
 
-// > chanum_1210 -f 1375.0610351 -F 0,8888,5 -o CasA02Dec.csh ../../crt*/PittsDec10/CasA02Dec/chanum_*.ppf
-// > chanum_1210 -f 1375.0610351 -F 0,8888,5 -o Crab03Dec.csh ../../crt*/PittsDec10/Crab03Dec/chanum_*.ppf
-// > chanum_1210 -f 1382.5378418 -F 0,8888,5 -o Sun03Dec.csh  ../../crt*/PittsDec10/Sun03Dec/chanum_*.ppf
-// > chanum_1210 -f 1390.0146484 -F 0,8888,5 -o CasA03Dec.csh ../../crt*/PittsDec10/CasA03Dec/chanum_*.ppf
+// > chanum_1210 -f 1375.0610351 -o CasA02Dec.csh ../../crt*/PittsDec10/CasA02Dec/chanum_*.ppf
+// > chanum_1210 -f 1375.0610351 -o Crab03Dec.csh ../../crt*/PittsDec10/Crab03Dec/chanum_*.ppf
+// > chanum_1210 -f 1382.5378418 -o Sun03Dec.csh  ../../crt*/PittsDec10/Sun03Dec/chanum_*.ppf
+// > chanum_1210 -f 1390.0146484 -o CasA03Dec.csh ../../crt*/PittsDec10/CasA03Dec/chanum_*.ppf
 
 int decode_numthread(string filein,string& dir);
@@ -31,5 +31,4 @@
 cout<<"Usage: chanum_1210 [options] chanum_?.ppf ..."<<endl
     <<" -f F0MHz : 1ere frequence pour cette acquisition (def=0.)"<<endl
-    <<" -F if0,if1,idf : selection freq de if0 a if1 moyenne par idf (def=\"0,8888,1\")"<<endl
     <<" -T it0,it1 : selection fichier temps de it0 a it1 (def=\"0,99999\")"<<endl
     <<" -o fichier.csh : nom du fichier de sortie pour les commandes a lancer"<<endl;
@@ -40,9 +39,9 @@
 {
   string outname = "chanum_1210.csh";
-  string selfreq = "0,8888,1", seltime = "0,99999";
+  string seltime = "0,99999";
   double freq0 = 0.;
 
   char c;
-  while((c = getopt(narg,arg,"hO:o:f:F:T:")) != -1) {
+  while((c = getopt(narg,arg,"hO:o:f:T:")) != -1) {
     switch (c) {
     case 'f' :
@@ -51,7 +50,4 @@
     case 'o' :
       outname = optarg;
-      break;
-    case 'F' :
-      selfreq = optarg;
       break;
     case 'T' :
@@ -108,6 +104,5 @@
   for(uint_4 i=0;i<vcode.size();i++) {
     char str[512];
-    sprintf(str,"time ${TACQEXE}/svv2mtx2_1210 -f %.7f -T %s -F %s"
-	    ,freq0,seltime.c_str(),selfreq.c_str());
+    sprintf(str,"time ${TACQEXE}/svv2mtx2_1210 -f %.7f -T %s",freq0,seltime.c_str());
     string argu = str;
     uint_4 ip = IVcode(i);
Index: /trunk/AddOn/TAcq/svv2mtx2_1210.cc
===================================================================
--- /trunk/AddOn/TAcq/svv2mtx2_1210.cc	(revision 3940)
+++ /trunk/AddOn/TAcq/svv2mtx2_1210.cc	(revision 3941)
@@ -41,5 +41,4 @@
     <<" -f freq0 : 1ere frequence en MHz"<<endl
     <<" -T it1,it2 : numero (temps) des fichiers a traiter [it1,it2]"<<endl
-    <<" -F if1,if2,ngrpfreq : numero des frequences [if1,if2] de [0,N[ a traiter et regroupement par ngrpfreq"<<endl
     <<"ATTENTION: lancer ce prog depuis le repertoire ou doivent etre ecrits les fichiers de visi"<<endl;
 }
@@ -56,8 +55,7 @@
   int vacq1=-1, vacq2=-1;
   int ifilmin=0, ifilmax=99999;
-  int jfr1=0, jfr2=-1, ngrpfreq=1;
 
   char c;
-  while((c = getopt(narg,arg,"hDCo:t:r:f:T:F:v:")) != -1) {
+  while((c = getopt(narg,arg,"hDCo:t:r:f:T:v:")) != -1) {
     switch (c) {
     case 'v' :
@@ -85,8 +83,4 @@
       sscanf(optarg,"%d,%d",&ifilmin,&ifilmax);
       if(ifilmin<0) ifilmin=0;
-      break;
-    case 'F' :
-      sscanf(optarg,"%d,%d,%d",&jfr1,&jfr2,&ngrpfreq);
-      if(ngrpfreq<=0) ngrpfreq=1;
       break;
     case 'h' :
@@ -106,5 +100,4 @@
   cout<<"freq0="<<freq0<<" MHz"<<endl;
   cout<<"request: file "<<ifilmin<<" to "<<ifilmax<<endl; if(ifilmax<ifilmin) return -3;
-  cout<<"request: freq "<<jfr1<<" to "<<jfr2<<" grouped by "<<ngrpfreq<<endl;
 
   InitTim();
@@ -163,6 +156,6 @@
   TMatrix< complex<r_4> > MVisi;
   TVector<r_8> MeanTT(nfile);
+  TVector<int_4> Npaqsum(nfile);
   TVector<r_4> Freq;
-  TVector<int_4> Npaqsum(nfile);
   string tudeb, tufin;
   double tudeb_day, tufin_day;
@@ -192,4 +185,5 @@
     MeanTT(ntimefill) = (double)vismtx.Info()["MeanTT"]/125.e6;
     uint_4 npaqsum = vismtx.Info()["NPAQSUM"];
+    Npaqsum(ntimefill) = npaqsum;
 
     // --- Initialisation purposes for the first read file
@@ -202,28 +196,8 @@
         return -5;
       }
-
-      // frequency grouping
-      int nfreq0 = vismtx.NCols();
-      cout<<"vismtx: number of frequencies = "<<nfreq0<<endl;
-      if(jfr1<=0) jfr1=0; if(jfr1>=nfreq0) jfr1=nfreq0-1;
-      if(jfr2<jfr1 || jfr2>=nfreq0) jfr2=nfreq0-1;
-      cout<<"frequency from jfr1="<<jfr1<<" to jfr2="<<jfr2<<" grouped by "<<ngrpfreq<<endl;
-      nfreq = 0; for(int i=jfr1;i<=jfr2;i+=ngrpfreq) nfreq++;
-      cout<<"frequency from [jfr1="<<jfr1<<" , jfr2="<<jfr2<<"] grouped by "<<ngrpfreq
-          <<": total of "<<nfreq<<" freq"<<endl;
-      Freq.ReSize(nfreq); Freq = 0.;
-      for(int i=0;i<nfreq;i++) {
-        int nf=0;
-        for(int j=0; j<ngrpfreq; j++) {
-          int f = jfr1 + i*ngrpfreq + j;
-          if(f>jfr2) break;
-          Freq(i) += f;
-	  nf++;
-	}
-        if(nf>0) Freq(i) /= (double)nf;
-	else {cout<<"ERROR: last freq bin with 0 freq in it"<<endl; return -6;}
-        if(i<4 || i>nfreq-4) cout<<"  F("<<i<<") = "<<Freq(i)<<" nf="<<nf<<endl;
-      }
-
+      // Frequency
+      nfreq = vismtx.NCols();
+      cout<<"vismtx: number of frequencies = "<<nfreq<<endl;
+      Freq.ReSize(nfreq); for(int i=0;i<nfreq;i++) Freq(i) = i;
       // allocate visib matrice <f> vs t
       cout<<"allocating visibility matrice ("<<nfile<<","<<nfreq<<") "
@@ -234,15 +208,7 @@
 
     // Fill time-freq visibility matrix
-    for(int i=0;i<nfreq;i++) {
-      int nf=0;
-      for(int j=0; j<ngrpfreq; j++) {
-        int f = jfr1 + i*ngrpfreq + j;
-        if(f>jfr2) break;
-        MVisi(ntimefill,i) += vismtx(numrow,f);
-        nf++;
-      }
-      Npaqsum(ntimefill) = nf * npaqsum;
-      MVisi(ntimefill,i) /= double(Npaqsum(ntimefill));
-      if(doconj) MVisi(ntimefill,i) = conj(MVisi(ntimefill,i));
+    for(int c=0;c<nfreq;c++) {
+      MVisi(ntimefill,c) = vismtx(numrow,c) / complex<r_4>(npaqsum);
+      if(doconj) MVisi(ntimefill,c) = conj(MVisi(ntimefill,c));
     }
     ntimefill++;
@@ -279,7 +245,8 @@
   dvl["freq0"] = freq0;
   dvl["dfreq0"] = 500./8192.;
-  dvl["jfr1"] = jfr1;
-  dvl["jfr2"] = jfr2;
-  dvl["ngrpfreq"] = ngrpfreq;
+  dvl["jfr1"] = 0;
+  dvl["jfr2"] = nfreq-1;
+  dvl["nfreq"] = nfreq;
+  dvl["ngrpfreq"] = 1;
   dvl["ifilmin"] = ifilmin;
   dvl["ifilmax"] = ifilmax;
@@ -298,6 +265,6 @@
     dum3.Info() = dvl;
     pos.PutObject(dum3,"visi");
-  }
-  pos.PutObject(Freq,"ifreq");
+    pos.PutObject(Freq,"ifreq");
+  }
 
   }
@@ -330,6 +297,4 @@
 n/plot ifreq.val%n ! ! "cpts"
 
-n/plot npaqsum.val%n ! ! "cpts"
-
 n/plot meantt.val%n ! ! "cpts"
 cp meantt dmeantt